; dacin.asm

!RAM_load_alt_level = $1F2B ; format l------c | l - load alternative gfx/level, c - minigame has been cleared

!RAM_skip_level_timer = $18B7 ; stores how long L+R have been held down in the fish minigame, if it has previously been cleared

!SMW_end_level_timer = $1493

Return018C17 = $818C17
Return0398EB = $8398EB
InitSpriteTables = $87F7D2;87F7D6
;level_load_pointer_done = $85D8E0 ; after l2 ptr loaded
level_load_pointer_done = $85D8D1 ; before l2 ptr loaded
gfx_load_pointer_done = $8ff927

org $85D8F9
	autoclean JSL sprite_pointer_loaded

org $85D8C2
	autoclean JML level_load_pointer
	NOP
level_load_pointer_back:

org $8FF917 ; LM ROUTINE
	autoclean JML gfx_load_pointer
gfx_load_pointer_back:

; org $83BBC9	; LM ROUTINE
	; autoclean JML load_messagebox_tilemap
; load_messagebox_tilemap_back = $83BBD5;:

org $0185C8+4+(2*$36) ; Sprite $36 main ptr
	dw spr36_main
org $018179+4+(2*$36) ; Sprite $36 init ptr
	dw spr36_init

org $0398DE
	autoclean JML teleport

spr36:
org $81FFF0
.main
	autoclean JML main
.init
	autoclean JML init

freecode
init:
	REP #$20
		LDA #$154A
		STA $9E		; sprite number
		LDA #$0101
		STA $14C8	; sprite state
		LDA #$7878
		STA $E4		; x low
		LDA #$B010
		STA $D8		; y low
		STZ $14E0	; x high
		STZ $14D4	; y high
		STZ $1A		; L1 X
		STZ $1C		; L1 Y
		STZ $1E		; L2 X
		STZ $20		; L2 Y
		STZ $1462	; L1 X, next frame
		STZ $1464	; L1 Y, next frame
		STZ $1466	; L2 X, next frame
		STZ $1468	; L2 Y, next frame
		STZ $1413	; L2 scroll settings = none
		STZ $148B	; RNG Seed
		STZ $148D	; RNG Output
		; LDA #$26DC	;
		; STA $0701	; BG Color
		; STA $0903	; BG Color Copy
	SEP #$20
	; STA $2132	; Upload BG Color
	; XBA
	; STA $2132	; Upload BG Color
	LDX #$00
	JSL InitSpriteTables
	INX
	JSL InitSpriteTables
	; LDA #$01
	STX $1633	; send fish behind net, to prevent interaction with player
	LDA #$02
	STA $1426	; trigger message box 2
	LDA #$29
	STA $13BF	; of level 105
	
	STZ $19		; powerup state
	STZ $0DC2	; item box
	LDA #$80
	TRB !RAM_load_alt_level	; Only load new OW event gfx
	LDX $15E9
;	JML Return018C17

main:
	LDA #$FF
	STA $78		; hide player
	STA $185C	; disable block interaction
	; move player to fish
	LDA $E5
	STA $94
	LDA $D9
	SEC : SBC #$10
	STA $96
	STZ $95
	STZ $97
	LDA !SMW_end_level_timer
	BNE .set_clear_flag ; branch if the level is ending
	LDA !RAM_load_alt_level
	BEQ .return
	LDA $17
	AND #$30
	CMP #$30
	BNE .not_cleared
	INC !RAM_skip_level_timer
	LDA !RAM_skip_level_timer
	CMP #$60
	BCC .return
	LDA #$FF					;$01877B	||\ 
	STA !SMW_end_level_timer	;$01877D	||| Start goal walk.
	STA $0DDA					;$018780	||/
	LDA #$0B					;$018783	||\ SFX for the goal sphere music.
	STA $1DFB					;$018785	|//
.not_cleared
	STZ !RAM_skip_level_timer
.return
	JML Return018C17

.set_clear_flag
	LDA #$01
	TSB !RAM_load_alt_level ; level is ending, make sure bit 0 is set
	JML Return018C17

teleport:
	LDX $95
	LDA #$05			; Level 0105
	STA $19B8,x			; low byte
	; LDA #$05			; 
	STA $19D8,x			; high bit + settings (use lm system)
	STZ $15				;\
	STZ $16				; | Disable Mario's controls
	STZ $17				; | 
	STZ $18				;/
	LDA #$0D			;\ Enter door animation
	STA $71				;/ (actually do nothing)
	STA $141A			; Set the level counter to a non-zero value
	LDA #$0F			; 
	STA $0100			;
	LDA #$80
	TSB !RAM_load_alt_level	; but load different L1 and sprite pointer
	LDX $15E9
	JML Return0398EB

sprite_pointer_loaded:
	LDA !RAM_load_alt_level
	BPL +	; load alt sprite pointer if bit 7 is set
	LDA.b #sprite_data
	STA $CE
	LDA.b #sprite_data>>8
	STA $CF
	LDA.b #sprite_data>>16
	STA $D0
+	LDA [$CE]
	AND #$3F
	RTL

level_load_pointer:
	LDA !RAM_load_alt_level
	BPL +	; load alt level pointer if bit 7 is set
	LDA.b #level_data_l1
	STA $65
	LDA.b #level_data_l1>>8
	STA $66
	LDA.b #level_data_l1>>16
	STA $67
;	LDA.b #level_data_l2
;	STA $68
;	LDA.b #level_data_l2>>8
;	STA $69
;	LDA.b #level_data_l2>>16
;	STA $6A
	JML level_load_pointer_done
+	LDA $e000,y
	STA $65
	JML level_load_pointer_back

gfx_load_pointer:
	;0ff917
	CPX #$1C
	BNE +
	LDA !RAM_load_alt_level
	BEQ +	; load alt gfx if not 0
	LDA.b #gfx0c_alt
	STA $8A
	LDA.b #gfx0c_alt>>8
	STA $8B
	LDA.b #gfx0c_alt>>16
	; STA $8C
	JML gfx_load_pointer_done
+	LDA.l $80B992,x
	JML gfx_load_pointer_back

; load_messagebox_tilemap:
	; ; 03BBD4
	; REP #$30
		; TXA
		; ASL
		; STA $00
		; TYA
		; CLC : ADC $00
		; ASL
		; TAX
		; CPX.w #$00A6
		; BEQ .load_alt_message
; +		JML load_messagebox_tilemap_back

; .load_alt_message
		; PHB
		; PEA $7F7F	; set DB to 7F
		; PLB : PLB
		; LDY $837B ; 7F837B
		; LDX #$0000
	; SEP #$20
; -	LDA.l message_tilemap,x
	; STA $837D,y
	; INX
	; INY
	; CMP #$FF
	; BNE -
	; DEY	; don't write FF byte to index
	; STY $837B ; 7F837B
	; PLB
	; SEP #$10
	; STZ $22
	; STZ $24
	; SEP #$30
	; LDA #$01
	; STA $13D5
	; RTL

print "gfx0c_alt: $",hex(gfx0c_alt)," (0x",hex(snestopc(gfx0c_alt)+$200),")"
print "sprite_data: $",hex(sprite_data)," (0x",hex(snestopc(sprite_data)+$200),")"
print "level_data_l1: $",hex(level_data_l1)," (0x",hex(snestopc(level_data_l1)+$200),")"
; print "message_tilemap: $",hex(message_tilemap)," (0x",hex(snestopc(message_tilemap)+$200),")"
;print "level_data_l2: $",hex(level_data_l2)," (0x",hex(snestopc(level_data_l2)+$200),")"
; message_tilemap:
	; db $50,$c7,$00,$23,$12,$39,$48,$39,$4d,$39,$42,$39,$44,$39,$1f,$39
	; db $1f,$39,$58,$39,$4e,$39,$54,$39,$1f,$39,$42,$39,$4b,$39,$44,$39
	; db $40,$39,$51,$39,$4b,$39,$58,$39
	; db $50,$e7,$00,$23,$4b,$39,$48,$39
	; db $4a,$39,$44,$39,$1f,$39,$1f,$39,$4f,$39,$4b,$39,$40,$39,$58,$39
	; db $48,$39,$4d,$39,$46,$39,$1f,$39,$56,$39,$48,$39,$53,$39,$47,$39
	; db $51,$07,$00,$23,$45,$39,$48,$39,$52,$39,$47,$39,$1d,$39,$1f,$39
	; db $1f,$39,$47,$39,$44,$39,$51,$39,$44,$39,$5d,$39,$52,$39,$1f,$39
	; db $52,$39,$4e,$39,$4c,$39,$44,$39,$51,$27,$00,$23,$10,$39,$54,$39
	; db $40,$39,$4b,$39,$48,$39,$53,$39,$58,$39,$1f,$39,$06,$39,$40,$39
	; db $4c,$39,$44,$39,$4f,$39,$4b,$39,$40,$39,$58,$39,$7b,$39,$7c,$39
	; db $51,$47,$00,$23,$56,$39,$48,$39,$53,$39,$47,$39,$1f,$39,$1f,$39
	; db $1f,$39,$45,$39,$48,$39,$52,$39,$47,$39,$1f,$39,$1f,$39,$1f,$39
	; db $4c,$39,$40,$39,$43,$39,$44,$39,$51,$67,$00,$23,$49,$39,$54,$39
	; db $52,$39,$53,$39,$1f,$39,$45,$39,$4e,$39,$51,$39,$1f,$39,$58,$39
	; db $4e,$39,$54,$39,$1f,$39,$5e,$39,$5c,$39,$1f,$39,$1f,$39,$1f,$39
	; db $51,$87,$00,$23,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39
	; db $1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39
	; db $1f,$39,$1f,$39,$60,$39,$61,$39,$51,$a7,$00,$23,$1f,$39,$1f,$39
	; db $1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39
	; db $1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$1f,$39,$62,$39,$63,$39
	; db $ff
; .end
; 50C700234139543953391F3951394439
; 40394B394B3958391F39533947394E39
; 5439463947391D3950E7002353394739
; 44391F391F395139443940394B391F39
; 5039543944395239533948394E394D39
; 5107002348394D391F391F3953394739
; 483952391F391F394B39443955394439
; 4B391F39483952395127002356394739
; 4E391F391F39523953394E394B394439
; 1F3940394B394B391F39533947394439
; 5147002342394E3948394D391F391F39
; 463940394C3944391F3942394B394E39
; 5439433952395D395167002342394E39
; 48394D3952391F391F3940394D394339
; 1F391F3964391C3954394F3952391E39
; 5187002300394B394B391F3953394739
; 443958391F3943394E391F394D394E39
; 56391F394839523951A7002345394B39
; 58391F3940395639403958391F394139
; 443948394D3946391F3940394B394B39
; FF

gfx0c_alt:
	incbin "../../Graphics/GFX1C-alternate-compressed.bin"
sprite_data:
	db $00,$A1,$00,$36,$FF
level_data_l1:
	db $C0,$60,$98,$24,$02,$4D,$74,$07,$02,$51,$4B,$72,$00,$02,$51,$4B
	db $73,$10,$42,$52,$4A,$71,$00,$82,$52,$10,$4B,$7C,$10,$42,$50,$43
	db $70,$60,$02,$62,$42,$71,$00,$02,$72,$41,$74,$00,$02,$72,$41,$7B
	db $00,$02,$70,$41,$72,$01,$02,$71,$40,$75,$05,$02,$71,$41,$7C,$01
	db $02,$71,$48,$7C,$00,$02,$80,$47,$79,$00,$02,$80,$47,$76,$00,$02
	db $80,$48,$73,$00,$02,$80,$4A,$75,$00,$02,$80,$4A,$7A,$00,$02,$80
	db $43,$77,$01,$42,$81,$49,$77,$01,$42,$81,$46,$73,$01,$42,$81,$4D
	db $7C,$00,$02,$64,$4A,$70,$00,$02,$63,$4B,$71,$00,$02,$63,$4D,$73
	db $00,$02,$63,$40,$74,$00,$02,$53,$41,$71,$00,$02,$53,$42,$70,$00
	db $02,$53,$40,$7B,$00,$02,$54,$40,$7C,$03,$02,$61,$40,$70,$03,$02
	db $61,$41,$70,$00,$02,$61,$4B,$70,$00,$02,$61,$4C,$70,$12,$02,$61
	db $4E,$70,$1F,$02,$61,$4B,$7D,$00,$02,$51,$4A,$7E,$00,$82,$50,$10
	db $43,$7F,$60,$02,$60,$42,$7E,$00,$02,$70,$4A,$7F,$00,$02,$64,$4B
	db $7E,$00,$02,$64,$41,$7E,$00,$02,$54,$42,$7F,$00,$02,$54,$41,$7F
	db $00,$02,$61,$4C,$7D,$12,$02,$61,$4B,$7F,$00,$02,$61,$44,$75,$00
	db $02,$80,$44,$7A,$00,$02,$80,$44,$3A,$00,$06,$44,$35,$00,$06,$48
	db $3C,$00,$06,$48,$33,$00,$06,$48,$73,$00,$02,$80,$48,$7C,$00,$02
	db $80,$45,$72,$00,$02,$80,$45,$7D,$00,$02,$80,$48,$33,$00,$06,$48
	db $3C,$00,$06,$46,$7B,$01,$42,$81,$FF
;level_data_l2:
;	db $32,$00,$01,$04,$03,$04,$05,$06,$07,$08,$04,$09,$0A,$02,$01,$01
;	db $0C,$0D,$01,$0E,$04,$0F,$10,$06,$07,$06,$03,$12,$13,$14,$01,$01
;	db $0C,$0D,$15,$0C,$03,$12,$09,$06,$07,$08,$03,$16,$17,$18,$01,$15
;	db $00,$19,$1A,$00,$82,$03,$47,$06,$1C,$06,$04,$01,$05,$1D,$01,$0D
;	db $0D,$01,$1F,$0D,$04,$20,$05,$06,$21,$08,$0E,$01,$02,$00,$15,$23
;	db $19,$21,$1F,$00,$03,$0F,$10,$06,$21,$24,$0C,$09,$10,$0D,$23,$25
;	db $01,$01,$1F,$0D,$0E,$26,$01,$06,$01,$1F,$00,$27,$01,$0D,$28,$01
;	db $21,$21,$1F,$0D,$0C,$12,$09,$29,$2A,$2B,$0D,$0E,$01,$00,$28,$82
;	db $21,$15,$1F,$00,$00,$04,$05,$18,$00,$0D,$0D,$0C,$01,$0D,$2C,$01
;	db $2D,$01,$2E,$23,$19,$03,$06,$18,$82,$0D,$0C,$00,$01,$00,$05,$21
;	db $1F,$21,$30,$31,$21,$04,$06,$1D,$82,$0D,$0E,$00,$15,$23,$32,$01
;	db $1F,$21,$21,$07,$01,$03,$06,$19,$1A,$00,$82,$0D,$0B,$28,$21,$21
;	db $1F,$21,$21,$1C,$21,$03,$02,$21,$1F,$82,$0D,$04,$00,$28,$21,$21
;	db $33,$82,$21,$7F,$2D,$0E,$06,$01,$2E,$0D,$23,$19,$34,$28,$21,$21
;	db $01,$21,$35,$21,$1F,$0C,$06,$21,$08,$0D,$28,$21,$01,$36,$37,$21
;	db $21,$38,$39,$01,$1F,$0C,$02,$21,$30,$1A,$2C,$01,$01,$3A,$05,$01
;	db $2D,$06,$36,$2A,$2B,$3B,$06,$01,$35,$3C,$3D,$21,$01,$18,$3E,$21
;	db $1F,$3F,$00,$34,$40,$04,$06,$2A,$39,$1C,$21,$41,$01,$42,$36,$2A
;	db $2B,$1F,$40,$01,$0C,$03,$43,$3A,$28,$21,$35,$08,$01,$02,$19,$1A
;	db $00,$1F,$44,$01,$44,$04,$45,$18,$28,$01,$07,$08,$01,$06,$01,$1F
;	db $0D,$33,$04,$01,$03,$46,$01,$18,$28,$21,$07,$30,$01,$06,$2A,$2B
;	db $40,$21,$03,$01,$5C,$03,$47,$01,$42,$36,$2A,$07,$01,$01,$02,$40
;	db $3A,$0C,$01,$03,$01,$46,$04,$01,$43,$3A,$34,$48,$37,$01,$49,$3B
;	db $18,$44,$2A,$04,$4A,$4B,$4C,$4D,$4B,$18,$01,$2B,$3E,$4D,$4B,$46
;	db $42,$03,$34,$46,$49,$4E,$46,$46,$4E,$4F,$01,$00,$40,$50,$4E,$45
;	db $49,$04,$4D,$4B,$45,$49,$26,$45,$49,$49,$4D,$3A,$0C,$45,$43,$4A
;	db $26,$03,$46,$13,$01,$26,$47,$4A,$26,$26,$04,$4F,$0C,$4D,$4B,$49
;	db $26,$04,$CF,$00,$7F,$04,$09,$0A,$04,$0F,$01,$12,$26,$05,$01,$02
;	db $06,$21,$07,$21,$01,$0F,$27,$13,$0F,$27,$09,$20,$05,$06,$01,$06
;	db $02,$21,$07,$38,$15,$27,$16,$13,$51,$04,$05,$04,$02,$06,$09,$06
;	db $06,$21,$1C,$06,$0D,$03,$01,$13,$06,$03,$06,$0F,$10,$02,$12,$06
;	db $02,$52,$21,$24,$23,$03,$01,$17,$29,$16,$02,$27,$01,$29,$03,$02
;	db $06,$36,$2A,$2B,$28,$03,$01,$51,$1D,$01,$29,$0E,$09,$18,$53,$49
;	db $06,$23,$19,$1A,$28,$03,$09,$06,$0D,$01,$1D,$00,$27,$18,$0C,$26
;	db $14,$28,$21,$1F,$28,$04,$12,$06,$00,$15,$0D,$00,$16,$1D,$0C,$26
;	db $18,$2C,$21,$1F,$28,$7F,$53,$04,$06,$0D,$23,$19,$1A,$01,$00,$00
;	db $27,$18,$54,$01,$55,$2C,$0C,$03,$14,$0D,$28,$01,$1F,$15,$23,$19
;	db $03,$18,$54,$21,$24,$05,$0C,$04,$18,$0D,$2C,$21,$1F,$23,$25,$21
;	db $16,$1D,$54,$41,$2B,$05,$00,$03,$18,$0D,$05,$01,$33,$31,$21,$21
;	db $01,$55,$05,$08,$23,$32,$1A,$16,$1D,$00,$3E,$21,$21,$07,$21,$21
;	db $01,$24,$54,$08,$28,$21,$1F,$01,$0D,$0D,$28,$01,$01,$1C,$21,$2D
;	db $01,$3A,$54,$08,$28,$21,$1F,$15,$0D,$0D,$36,$52,$21,$21,$2D,$2B
;	db $01,$18,$3E,$24,$28,$21,$2B,$00,$00,$0D,$34,$36,$52,$21,$2E,$40
;	db $4A,$18,$23,$19,$31,$21,$2C,$00,$34,$0D,$2C,$01,$55,$28,$01,$08
;	db $0C,$49,$18,$28,$21,$07,$21,$40,$01,$0D,$54,$01,$24,$28,$21,$06
;	db $0C,$45,$4F,$28,$21,$1C,$21,$0C,$4D,$3A,$3E,$4D,$3A,$2C,$21,$3F
;	db $44,$01,$02,$28,$82,$21,$7F,$3B,$46,$18,$40,$04,$42,$05,$01,$33
;	db $04,$01,$06,$36,$52,$21,$56,$46,$45,$18,$0C,$03,$06,$54,$21,$21
;	db $04,$01,$49,$3A,$28,$21,$07,$45,$01,$4F,$0C,$04,$06,$57,$35,$01
;	db $03,$4D,$4B,$4F,$25,$41,$07,$4D,$01,$49,$3B,$03,$02,$58,$07,$37
;	db $03,$04,$13,$02,$01,$06,$07,$46,$4D,$4B,$50,$03,$06,$36,$39,$3E
;	db $03,$03,$4E,$06,$21,$08,$48,$47,$50,$4E,$47,$04,$06,$00,$36,$36
;	db $03,$04,$49,$02,$01,$3F,$2B,$04,$26,$49,$4C,$46,$06,$40,$3A,$34
;	db $04,$03,$26,$06,$2A,$2B,$40,$04,$26,$47,$46,$45,$06,$44,$42,$01
;	db $46,$46,$26,$02,$3A,$34,$0C,$CF,$00,$02,$01,$01,$02,$85,$01,$03
;	db $02,$01,$01,$02,$85,$01,$00,$02,$83,$01,$00,$02,$9B,$01,$04,$02
;	db $01,$01,$02,$02,$85,$01,$03,$02,$01,$01,$02,$86,$01,$01,$02,$02
;	db $84,$01,$00,$02,$8B,$01,$01,$02,$02,$85,$01,$00,$02,$85,$01,$00
;	db $02,$8C,$01,$00,$02,$84,$01,$05,$02,$01,$02,$01,$01,$02,$85,$01
;	db $02,$02,$01,$02,$8A,$01,$01,$02,$02,$85,$01,$00,$02,$84,$01,$00
;	db $02,$82,$01,$00,$02,$83,$01,$00,$02,$83,$01,$00,$02,$8B,$01,$00
;	db $02,$84,$01,$00,$02,$89,$01,$00,$02,$87,$01,$00,$02,$91,$01,$03
;	db $02,$01,$01,$02,$83,$01,$06,$02,$01,$01,$02,$02,$01,$02,$84,$01
;	db $00,$02,$89,$01,$03,$02,$01,$01,$02,$96,$01,$03,$02,$01,$01,$02
;	db $83,$01,$00,$02,$82,$01,$00,$02,$83,$01,$00,$02,$82,$01,$00,$02
;	db $97,$01,$02,$02,$01,$02,$82,$01,$00,$02,$8F,$01,$00,$02,$96,$01
;	db $00,$02,$84,$01,$00,$02,$97,$01,$00,$02,$85,$01,$00,$02,$CF,$00
;	db $89,$01,$00,$02,$8F,$01,$00,$02,$87,$01,$03,$02,$01,$01,$02,$85
;	db $01,$00,$02,$88,$01,$03,$02,$01,$01,$02,$88,$01,$00,$02,$83,$01
;	db $00,$02,$A4,$01,$06,$02,$01,$01,$02,$01,$01,$02,$89,$01,$00,$02
;	db $85,$01,$00,$02,$83,$01,$00,$02,$86,$01,$00,$02,$88,$01,$02,$02
;	db $01,$02,$8C,$01,$00,$02,$83,$01,$01,$02,$02,$85,$01,$00,$02,$85
;	db $01,$00,$02,$90,$01,$01,$02,$02,$99,$01,$01,$02,$02,$8C,$01,$00
;	db $02,$85,$01,$00,$02,$8F,$01,$00,$02,$91,$01,$00,$02,$87,$01,$05
;	db $02,$01,$02,$02,$01,$02,$8E,$01,$00,$02,$89,$01,$00,$02,$82,$01
;	db $00,$02,$8B,$01,$00,$02,$83,$01,$01,$02,$01,$82,$02,$94,$01,$02
;	db $02,$01,$02,$82,$01,$03,$02,$01,$02,$02,$8A,$01,$00,$02,$91,$01
;	db $00,$02,$82,$01,$CF,$00,$FF,$FF
