; patches out spawn transferal (where you spawn a sprite on the same frame
;    that another despawns and it transfers the spawn index at 161A to the new
;    sprite allowing you to duplicate almost arbitrarily) by moving the code that
;    clears 161A to the sprite initilization routine. Except for when it's intentional.

; This patch is very likely not compatbile with any sprite tool, though I have not tested that.

org $018151 ; return immediately when there is not sprite in this slot
	rep 5 : RTS

; InitSpriteTables/don't clear for these, keeping the spawn index is intentional here
;  $018C34 ; changes spiny egg into spiny
;  $01A2DC ; changes baby yoshi into adult yoshi
;  $01F855 ; changes yoshi egg into baby yoshi
;  $01F867 ; changes yoshi egg into 1-up
;  $01F86C ; changes yoshi egg into adult yoshi
;  $02A132 ; changes a sprite into a coin when hit by a fireball
;  $02A9B9 ; spawns a silver coin (when any enemy spawns naturally but the silver p-switch is active) which already set 161A previously
;  $02A9C9 ; spawns a sprite naturally which already set 161A previously
;  $02B9E5 ; changes a sprite into a coin when a silver p-switch is pressed
;  $02D980 ; changes a bubble into the relevant sprite when popped
;  $02E467 ; changes an exploding block into the relevant sprite
;  $03897A ; changes a sliding blue koopa into a normal one
;  $03C31C ; changes an invisible mushroom into a visible one
;  $03C083 ; changes baby yoshi into adult yoshi (when double eating)

; maybe don't clear these? probably should be cleared though:
;  $01BC97 ; magikoopas magic hitting a block and changing into one of the spawnable sprites
;  $00FB60 ; sprites at the end of the level changing into other sprites (doesn't really matter as the level is over anyway)

; LoadSpriteTables/unsure? probably don't clear
;  $019675 ; resets a shell when a koopa enters it? probably don't want to reset it here, not entirely sure what it does though

; LoadSpriteTables/don't clear
;  $01A9A4 ; changes a sprite into a different type when stomped (winged koopa/goomba, dino rhino etc)
;  $01C335 + $01C340 ; temporarily changes the changing item sprite into a powerup when touched
;  $01D67C ; changes parachute enemies into the relevant sprite
;  $01F2F9 ; changes a sprite when spat out of yoshis mouth and the 'spawns new sprite' tweaker bit is set
;  $02949E ; changes sprites into a different type when stomped (shells, buzzy beetle, etc), different list from $01A9A4, not sure which exactly are included where
;  $02E0CD ; reloads tweaker bytes for jumping piranha (why??)
;  $038197 ; reloads tweaker bytes for big boo boss when hit (again, why??)
; and that's all of them. Never want to clear 161A when that routine is called which makes sense, sort of.


org $07F7D2 ; InitSpriteTables
	autoclean JML clear161A

; Transferring the spawn index to the next sprite is intended here, don't clear it
org $018C34 : autoclean JSL dontClear161A
org $01A2DC : autoclean JSL dontClear161A
org $01F855 : autoclean JSL dontClear161A
org $01F867 : autoclean JSL dontClear161A
org $01F86C : autoclean JSL dontClear161A
org $02A132 : autoclean JSL dontClear161A
org $02A9B9 : autoclean JSL dontClear161A
org $02A9C9 : autoclean JSL dontClear161A
org $02B9E5 : autoclean JSL dontClear161A
org $02D980 : autoclean JSL dontClear161A
org $02E467 : autoclean JSL dontClear161A
org $03897A : autoclean JSL dontClear161A
org $03C31C : autoclean JSL dontClear161A
org $03C083 : autoclean JSL dontClear161A

freecode
clear161A:
	LDA #$FF
	STA $161A,x
dontClear161A:
	JSL $87F722 ; zero sprite tables
	JML $87F78B ; load tweaker bytes
